      SUBROUTINE GETLGRRSP(FN,INTFLG)
      
      CHARACTER*40 FN
      CHARACTER*200 COMLIN
      
      INTEGER INTFLG
      
      LOGICAL EXISTS
        FN=' '
        COMLIN=' '

C *** Subroutines GETARG and GETCL are extensions to Fortran 90/95 that
C *** allow a program to retrieve command-line arguments.  To enable
C *** Modflow-2000 to read the name of a Name file from the command
C *** line, either GETARG or GETCL must be called, but not both.  As
C *** distributed, the call to GETARG is uncommented.  For compilers
C *** that support GETCL but not GETARG, comment out the call to GETARG
C *** and uncomment the call to GETCL.  The calls to both GETARG and
C *** GETCL may be commented out for compilers that do not support
C *** either extension.
      CALL GETARG(1,COMLIN)
C      CALL GETCL(COMLIN)
      ICOL = 1
      IF(COMLIN.NE.' ') THEN
         FN=COMLIN
         IF(FN.EQ.'i'.OR.FN.EQ.'I') THEN
            INTFLG=0
            WRITE (*,*) 'INTERACTIVE INPUT FOR A SINGLE MODEL'
            RETURN
         END IF
      ELSE
   15   WRITE(*,*)'ENTER NAME OF EXISTING MODPATH-LGR RESPONSE FILE:' 
        WRITE(*,*)'( <CR> = INTERACTIVE DATA INPUT FOR A SINGLE MODEL )'
         READ (*,'(A)') FN                                           
         ICOL=1
         CALL URWORD(FN,ICOL,ISTART,ISTOP,0,N,R,0,0)                 
         FN=FN(ISTART:ISTOP)
         IF (FN.EQ.' ') THEN
            INTFLG=0 
            WRITE (*,*) 'INTERACTIVE INPUT FOR A SINGLE MODEL'
            RETURN
         END IF
      END IF
      INQUIRE (FILE=FN,EXIST=EXISTS)                              
      IF(.NOT.EXISTS) THEN                                             
          NC=INDEX(FN,' ')                                        
          FN(NC:NC+3)='.rsp'                                      
          INQUIRE (FILE=FN,EXIST=EXISTS)                          
          IF(.NOT.EXISTS) THEN                                         
              WRITE (*,100) FN(1:NC-1),FN(1:NC+3)            
  100         FORMAT('Can''t find response file ',A,' or ',A)       
              CALL USTOP(' ')                                          
          ENDIF                                                        
      ENDIF  
      RETURN
      END SUBROUTINE GETLGRRSP

C----------------------------------------------------------------
      SUBROUTINE ISSLGR(IN,INN,IOUT,FNRSP,FNLGR,ISLGR,NGRIDS)
      IMPLICIT NONE
      REAL R
      INTEGER IN, INN,ISLGR, IOUT,ICOL,ISTART,ISTOP,N
      INTEGER ILGR,NC,ILGRSTAT,NGRIDS
      INTEGER IIOUT
      CHARACTER*80 LINE,FNRSPPARENT,FNLGR,FNMPLGR
      CHARACTER*40 FNRSP
      LOGICAL EXISTS
      
      OPEN(UNIT=IN,FILE=FNRSP)                             
      ISLGR=1

C     DETERMINE IF THE FILE IS A MODPATH RESPONSE FILE
      CALL URDCOM(IN,0,LINE)
      ICOL = 1
      CALL URWORD(LINE,ICOL,ISTART,ISTOP,0,N,R,0,0)
      FNLGR=LINE(ISTART:ISTOP)

      IF (LINE(ISTART:ISTOP).EQ.'@[MODPATH-LGR'
     1 .OR.LINE(ISTART:ISTOP).EQ.'@[MODPATH') THEN
         ISLGR=0
         CLOSE(IN)
         WRITE(*,*) 'RUNNING MODPATH-LGR FOR ONE MODEL'
      ELSE
C--------CHECK IF THE FILE IS A MODPATH-LGR RESPONSE FILE      
         FNLGR=LINE(ISTART:ISTOP)
         INQUIRE (FILE=FNLGR,EXIST=EXISTS)                               
         IF(.NOT.EXISTS) THEN                                            
             NC=INDEX(FNLGR,' ')                                         
             FNLGR(NC:NC+3)='.lgr'                                       
             INQUIRE (FILE=FNLGR,EXIST=EXISTS)                           
             IF(.NOT.EXISTS) THEN
                 ILGRSTAT=.FALSE.                                        
                 WRITE (*,110) FNLGR(1:NC-1),FNLGR(1:NC+3)               
  110            FORMAT('Can''t find LGR control file or MODPATH-LGR ', 
     1            'response file ',A,' or ',A)
                 CALL USTOP(' ')                                         
             ENDIF                                                       
         ENDIF
  120 FORMAT('MODFLOW-LGR CONTROL FILE:', 18(' '), '<',A,'>')
      WRITE(IOUT,120) TRIM(ADJUSTL(FNLGR))
      WRITE(IOUT,*) ''      

C-----OPEN THE FILE AND SEE IF THE FIRST CHARACTERS ARE "LGR"           
         OPEN(INN,FILE=FNLGR,STATUS='UNKNOWN')
         CALL URDCOM(INN,IIOUT,LINE)                             
         ICOL = 1
         CALL URWORD(LINE,ICOL,ISTART,ISTOP,0,N,R,0,INN)           
         IF (LINE(ISTART:ISTOP).EQ.'LGR') THEN
                ISLGR=1
         ELSE
            WRITE(*,*) 'ERROR READING MODPATH-LGR CONTROL FILE'
            CALL USTOP(' ') 
         ENDIF

C--------READ THE NUMBER OF GRIDS
         READ(INN,'(A)') LINE
         ICOL = 1
         CALL URWORD(LINE,ICOL,ISTART,ISTOP,2,NGRIDS,R,0,INN)   
         WRITE(*,*) 'RUNNING MODPATH-LGR for',NGRIDS,' GRIDS'
      END IF

      RETURN
      END SUBROUTINE ISSLGR
C----------------------------------------------------------------------------

      SUBROUTINE GETLGR(INUNIT,FNLGR,FNNAMPARENT,FNNAMCHILD,NGRIDS,
     1 NPCBEG,NPREND,NCPP)
      IMPLICIT NONE
      
      INTEGER INUNIT,IOUT,ISTART,ISTOP,N,ICOL,ITYP1,ITYP2,IU,NC
      INTEGER INAM1,INAM2,ILGR,NGRIDS,LG,NPL
      INTEGER NPLBEG,NPRBEG,NPCBEG,NPLEND,NPREND,NPCEND,NCPP,NCPPL
      REAL R
      CHARACTER*80 FNLGR,FN,FNNAMPARENT,FNNAMCHILD,LINE
      CHARACTER*80 GRIDSTATUSP,GRIDSTATUSC,LGR
      LOGICAL EXISTS
 
      DIMENSION NPLBEG(NGRIDS-1)
      DIMENSION NPRBEG(NGRIDS-1)
      DIMENSION NPCBEG(NGRIDS-1)
      DIMENSION NPLEND(NGRIDS-1)
      DIMENSION NPREND(NGRIDS-1)
      DIMENSION NPCEND(NGRIDS-1)
      DIMENSION NCPP(NGRIDS-1)
      DIMENSION FNNAMCHILD(NGRIDS-1)           
      DIMENSION NCPPL(NGRIDS-1,99)

C-------READ THE PARENT NAME FILE      
      READ(INUNIT,'(A)') LINE
      ICOL=1
      CALL URWORD(LINE,ICOL,ISTART,ISTOP,0,N,R,0,INUNIT)
      FNNAMPARENT=LINE(ISTART:ISTOP)                                  
      INQUIRE (FILE=FNNAMPARENT,EXIST=EXISTS)
      IF(.NOT.EXISTS) THEN                                           
          NC=INDEX(FNNAMPARENT,' ')
          FNNAMPARENT(NC:NC+3)='.nam'
          INQUIRE (FILE=FNNAMPARENT,EXIST=EXISTS)
          IF(.NOT.EXISTS) THEN
              WRITE (*,100) FNNAMPARENT(1:NC-1),FNNAMPARENT(1:NC+3)
  100         FORMAT('CAN''T FIND THE NAME FILE FOR THE
     1        PARENT GRID ',A,' or ',A)                          
              CALL USTOP(' ')
          ENDIF
      ENDIF

C-------READ GRIDSTATUS FOR PARENT GRID
      ICOL=1
      READ(INUNIT,'(A)') LINE
      CALL URWORD(LINE,ICOL,ISTART,ISTOP,0,N,R,0,INUNIT)
      GRIDSTATUSP=LINE(ISTART:ISTOP) 
            
C-------SKIP OVER BFH INFO IUPBHSV, IUPBFSV
      READ(INUNIT,*)
      DO LG=1,NGRIDS-1 
C--------READ THE CHILD NAME FILE 
         READ(INUNIT,'(A)') LINE
         ICOL=1
         CALL URWORD(LINE,ICOL,ISTART,ISTOP,0,N,R,0,INUNIT)
         FNNAMCHILD(LG)=LINE(ISTART:ISTOP)
         INQUIRE (FILE=FNNAMCHILD(LG),EXIST=EXISTS)
         IF(.NOT.EXISTS) THEN                                           
            NC=INDEX(FNNAMCHILD(LG),' ')
            FNNAMCHILD(LG)(NC:NC+3)='.nam'
            INQUIRE (FILE=FNNAMCHILD(LG),EXIST=EXISTS)
            IF(.NOT.EXISTS) THEN
               WRITE (*,200) FNNAMCHILD(LG)(1:NC-1),
     1          FNNAMCHILD(LG)(1:NC+3)
  200          FORMAT('CAN''T FIND NAME FILE FOR THE
     1         CHILD GRID ',A,' or ',A)                          
               CALL USTOP(' ')
            ENDIF
         ENDIF
   
C--------READ GRIDSTATUS FOR CHILD GRID
         ICOL=1
         READ(INUNIT,'(A)') LINE
         CALL URWORD(LINE,ICOL,ISTART,ISTOP,0,N,R,0,INUNIT)
         GRIDSTATUSC=LINE(ISTART:ISTOP) 
C--------SKIP OVER ISHFLG,IBFLG,IUCBHSV,IUCBFSV
C        CALL URDCOM(INUNIT,IOUT,LINE)
        READ(INUNIT,'(A)') LINE
C--------SKIP OVER MXLGRITER, IOUTLGR
        READ(INUNIT,'(A)') LINE
C--------SKIP OVER RELAXH, RELAXF        
        READ(INUNIT,'(A)') LINE
C--------SKIP OVER HCLOSELGR,FCLOSELGR
        READ(INUNIT,'(A)') LINE
C--------READ IN DATA FOR CHILD/PARENT MESH INTERFACE LOCATION AND 
C        REFINEMENT INFO
        READ(INUNIT,*)  NPLBEG(LG),NPRBEG(LG),NPCBEG(LG)
        READ(INUNIT,*)  NPLEND(LG),NPREND(LG),NPCEND(LG)  
        READ(INUNIT,*)  NCPP(LG)
        READ(INUNIT,*) (NCPPL(LG,NPL), NPL=1,NPLEND(LG))
      END DO
      
      RETURN
      END SUBROUTINE GETLGR



C**********************************************************************

C     READ THE PARENT GRID RESPONSE FILE AND GET MODPATH FILE NAMES

      SUBROUTINE GETMP(INNAM,FNMAIN,FNBUD,FNSTART,
     1 FNPATH,FNEND,FNTS,FNPROJ,IOUTPL,IOUTEP,IOUTTS,IOUTPJ)
      
      IMPLICIT NONE
      INTEGER INRSP,INNAM,IOUT,ISTART,ISTOP,N,ICOL,ITYP1,ITYP2,IU
      INTEGER INAM1,INAM2,INUNIT
      INTEGER IOUTPL,IOUTEP,IOUTTS,IOUTPJ
      REAL R
      CHARACTER*80 LINE
      CHARACTER*80 FTYPEMAIN,FTYPEBUD,FTYPESTART,FTYPEPATH,FTYPEEND,
     1 FTYPETS,FTYPEPROJ
      CHARACTER*80 FNRSP,FNMPNAM,FNMAIN,FNBUD,FNSTART,FNPATH,FNEND,FNTS,
     1 FNPROJ
      LOGICAL EXISTS
      
      FTYPEMAIN='MAIN'
      FTYPEBUD='BUDGET'
      FTYPESTART='LOCATIONS'
      FTYPEPATH='PATHLINE'
      FTYPEEND='ENDPOINT'
      FTYPETS='TIME-SERIES'
      FTYPEPROJ='ADVOBS'

      IOUT = 0 

C2----READ A LINE; IGNORE BLANK LINES AND COMMENTS
  300 READ(INNAM,'(A)',END=350) LINE
      IF(LINE.EQ.' ') GO TO 300
         IF(LINE(1:1).EQ.'#') THEN
         GO TO 300
      END IF
C3----DECODE THE FILE TYPE AND UNIT NUMBER.
      ICOL=1
      CALL URWORD(LINE,ICOL,ISTART,ISTOP,1,N,R,IOUT,INNAM)
      IF(LINE(ISTART:ISTOP).EQ.FTYPEMAIN) THEN 
         CALL URWORD(LINE,ICOL,INAM1,INAM2,2,IU,R,IOUT,INNAM)
         CALL URWORD(LINE,ICOL,INAM1,INAM2,0,N,R,IOUT,INNAM)      
         FNMAIN=LINE(INAM1:INAM2)
      ELSE IF(LINE(ISTART:ISTOP).EQ.FTYPEBUD) THEN 
         CALL URWORD(LINE,ICOL,INAM1,INAM2,2,IU,R,IOUT,INNAM)
         CALL URWORD(LINE,ICOL,INAM1,INAM2,0,N,R,IOUT,INNAM)      
         FNBUD=LINE(INAM1:INAM2)
      ELSE IF(LINE(ISTART:ISTOP).EQ.FTYPESTART) THEN
         CALL URWORD(LINE,ICOL,INAM1,INAM2,2,IU,R,IOUT,INNAM)      
         CALL URWORD(LINE,ICOL,INAM1,INAM2,0,N,R,IOUT,INNAM)      
         FNSTART=LINE(INAM1:INAM2)
      ELSE IF(LINE(ISTART:ISTOP).EQ.FTYPEPATH) THEN
         CALL URWORD(LINE,ICOL,INAM1,INAM2,2,IOUTPL,R,IOUT,INNAM)      
         CALL URWORD(LINE,ICOL,INAM1,INAM2,0,N,R,IOUT,INNAM)      
         FNPATH=LINE(INAM1:INAM2)
      ELSE IF(LINE(ISTART:ISTOP).EQ.FTYPEEND) THEN
         CALL URWORD(LINE,ICOL,INAM1,INAM2,2,IOUTEP,R,IOUT,INNAM)      
         CALL URWORD(LINE,ICOL,INAM1,INAM2,0,N,R,IOUT,INNAM)      
         FNEND=LINE(INAM1:INAM2)
      ELSE IF(LINE(ISTART:ISTOP).EQ.FTYPETS) THEN
         CALL URWORD(LINE,ICOL,INAM1,INAM2,2,IOUTTS,R,IOUT,INNAM)      
         CALL URWORD(LINE,ICOL,INAM1,INAM2,0,N,R,IOUT,INNAM)      
         FNTS=LINE(INAM1:INAM2)
      ELSE IF(LINE(ISTART:ISTOP).EQ.FTYPEPROJ) THEN
         CALL URWORD(LINE,ICOL,INAM1,INAM2,2,IOUTPJ,R,IOUT,INNAM)      
         CALL URWORD(LINE,ICOL,INAM1,INAM2,0,N,R,IOUT,INNAM)      
         FNPROJ=LINE(INAM1:INAM2)
                  
      END IF
      GO TO 300
  350 CONTINUE 
      
      RETURN
      END SUBROUTINE GETMP

C**********************************************************************                                                                             

      SUBROUTINE GETFNAM(IUNIT,FNAME,EXT)

      IMPLICIT NONE
      
      CHARACTER*4 EXT
      CHARACTER*80 FNAME,LINE
      INTEGER ICOL,IUNIT,IOUT,ISTART,ISTOP,N,NC

      REAL R
      
      LOGICAL EXISTS
      
      CALL URDCOM(IUNIT,IOUT,LINE)                      
      ICOL=1                                                  
      CALL URWORD(LINE,ICOL,ISTART,ISTOP,0,N,R,0,IUNIT) 
      FNAME=LINE(ISTART:ISTOP)                          
      INQUIRE (FILE=FNAME,EXIST=EXISTS)                 
      IF(.NOT.EXISTS) THEN                                    
         NC=INDEX(FNAME,' ')                            
         FNAME(NC:NC+3)=EXT                          
         INQUIRE (FILE=FNAME,EXIST=EXISTS)              
         IF(.NOT.EXISTS) THEN                                 
            WRITE (*,220) FNAME(1:NC-1),FNAME(1:NC+3)
  220       FORMAT('Can''t find file ',A,' or ',A)     
            CALL USTOP(' ')                                   
         ENDIF                                                
      ENDIF
      RETURN
      END SUBROUTINE GETFNAM

C**********************************************************************                                                                             
                    
      SUBROUTINE GETMAIN(IUNIT,FNAME,ICMPCT)
C     THIS SUBROUTINE OPENS THE MODPATH MAIN DATA FILE AND READS VARIOUS
C     MODPATH VARIABLES
      
      CHARACTER*40 FNAME, LINE
      INTEGER IUNIT,ICMPCT,IXREAD
      ICMPCT=0
      IXREAD=0
            
      OPEN(IUNIT,FILE=FNAME,STATUS='OLD')
      READ(IUNIT,'(A)',END=500) LINE
      READ(IUNIT,'(A)',END=500) LINE     
                                                          
      CALL UPCASE(LINE)                                                 
      IF(INDEX(LINE,'XSECTION').NE.0) IXREAD=1                          
      IF(INDEX(LINE,'COMPACT').NE.0) ICMPCT=1                           
      IF(INDEX(LINE,'BINARY') .NE. 0) ICMPCT=2                          
      
      CLOSE(IUNIT)

  500 RETURN
      END SUBROUTINE GETMAIN
      


C**********************************************************************                                                                             

                   
      SUBROUTINE GETDIS(INUNIT,IUNIT,CUNIT,NIUNIT,IUDIS,FNDIS,INDIS,
     1 IUOUT)

c     This subroutine opens the files out of the name file and reads the
c     DIS file to get array sizes and time discretization.
C
      IMPLICIT NONE
      INTEGER     IUNIT,INUNIT,NIUNIT,IUDIS,INDIS,IUOUT
      INTEGER     N,ISTART,ISTOP,LLOC,ITYP1,ITYP2,IU,I,IDUM,
     1            INAM1,INAM2,IFLEN,IOUT, IOUTG,K,KK
      
      DIMENSION   IUNIT(NIUNIT)
      
      REAL        R
      
      CHARACTER*4 CUNIT(NIUNIT), CDUM
      CHARACTER*80 LINE,FNAME,FNDIS
      CHARACTER*40 dummy

      CHARACTER*24 ANAME(5)                     
      DATA ANAME(1) /'                    DELR'/
      DATA ANAME(2) /'                    DELC'/
      DATA ANAME(3) /'TOP ELEVATION OF LAYER 1'/
      DATA ANAME(4) /'  MODEL LAYER BOTTOM EL.'/      
      DATA ANAME(5) /'BOT. EL. OF QUASI-3D BED'/

C     initialize IUNIT to zero 
      DO I = 1, NIUNIT         
         IUNIT(I) = 0
      END DO
      IOUT = 0          !set default output 
      IOUTG = 0
      
C2----READ A LINE; IGNORE BLANK LINES AND COMMENTS
  105 READ(INUNIT,'(A)',END=500) LINE
      IF(LINE.EQ.' ') GO TO 105
         IF(LINE(1:1).EQ.'#') THEN
         GO TO 105
      END IF
C3----DECODE THE FILE TYPE AND UNIT NUMBER.
      LLOC=1
      CALL URWORD(LINE,LLOC,ITYP1,ITYP2,1,N,R,IOUT,INUNIT)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IU,R,IOUT,INUNIT)

C4E---CHECK FOR MAJOR OPTIONS.
      DO I=1,NIUNIT
         IF(LINE(ITYP1:ITYP2).EQ.CUNIT(I)) THEN
            IUNIT(I)=IU
c              FILSTAT='OLD    '
c              FILACT=ACTION(1)
         END IF
      END DO
c     WRITE(IOUTG,21) LINE(ITYP1:ITYP2)
c     STOP
      IF(IUNIT(IUDIS) .EQ. IU) THEN              ! DIS file
         CALL URWORD(LINE,LLOC,INAM1,INAM2,0,N,R,IOUTG,INUNIT)
         IFLEN=INAM2-INAM1+1
         FNAME(1:IFLEN)=LINE(INAM1:INAM2)
         FNDIS=FNAME(1:IFLEN)
         INDIS=IU
      END IF
      GO TO 105

 500  CONTINUE

C------CHECK FOR EXISTANCE OF DISCRETIZATION FILE

      IF(INDIS.LE.0) THEN
         WRITE(*,*) ' DIS file must be specified for program to run'
         STOP
      END IF

      RETURN
      END SUBROUTINE GETDIS


C**********************************************************************
      SUBROUTINE ARDIS(INDIS,FNDIS,NCOL,NROW,NLAY,NPER,IOUT)
      
      IMPLICIT NONE
      
      INTEGER     INDIS  
      INTEGER     NCOL,NROW,NLAY,NPER
      INTEGER     LAYCBD,LBOTM,NCNFBD,NBOTM,K
      INTEGER     LLOC,IOUT,ISTOP,ISTART
      REAL        DELR,DELC,TOP,BOTM
      REAL        R
      
      CHARACTER*80 FNDIS,LINE

C5------READ NUMBER OF LAYERS, ROWS, COLUMNS, STRESS PERIODS
C
C6------READ 1st RECORD AND CHECK FOR COMMENTS
   20 READ(INDIS,'(A)') LINE
      IF(LINE(1:1).EQ.'#') GOTO 20
      LLOC=1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NLAY,R,IOUT,INDIS)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NROW,R,IOUT,INDIS)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NCOL,R,IOUT,INDIS)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NPER,R,IOUT,INDIS)
      RETURN
      END SUBROUTINE ARDIS

CC********************************************************************

      SUBROUTINE RDDIS(INDIS,NCOL,NROW,NLAY,NPER,DELR,DELC,TOP,BOTM,
     1 PERLEN,NSTP,TSMULT,ISSFLG,IOUT)
      
      IMPLICIT NONE
      
      INTEGER     NCOL,NROW,NLAY,NPER
      INTEGER     INDIS
      INTEGER     N,ISTART,ISTOP,LLOC,IU,I,IDUM
      INTEGER     INAM1,INAM2,IFLEN,IOUT, IOUTG,II,JJ,K,KK
      INTEGER     LAYCBD,LBOTM,NCNFBD,NBOTM,ISSFLG,NSTP
      INTEGER     ISS,ITR,ITRSS

      REAL        R,ZERO
      REAL        DELR,DELC,TOP,BOTM,TSMULT,PERLEN
      
      DIMENSION DELR(NCOL),DELC(NROW)
      DIMENSION TOP(NROW,NCOL,NLAY)
      DIMENSION BOTM(NROW,NCOL,NLAY)
      DIMENSION LAYCBD(NLAY),LBOTM(NLAY)
      DIMENSION PERLEN(NPER),NSTP(NPER),TSMULT(NPER),ISSFLG(NPER)

      CHARACTER*200 LINE,FNAME
      CHARACTER*40 dummy
      
      CHARACTER*24 ANAME(5)                     
      DATA ANAME(1) /'                    DELR'/
      DATA ANAME(2) /'                    DELC'/
      DATA ANAME(3) /'TOP ELEVATION OF LAYER 1'/
      DATA ANAME(4) /'  MODEL LAYER BOTTOM EL.'/      
      DATA ANAME(5) /'BOT. EL. OF QUASI-3D BED'/

C8------Read confining bed information
      READ(INDIS,*) (LAYCBD(K),K=1,NLAY)
      LAYCBD(NLAY)=0

CC9------Count confining beds, setup the pointer to each layer's
CC9------bottom array (LBOTM), and setup LAYCBD to be the confining
CC9------bed number for each layer.

C11-----Read the DELR and DELC arrays.
      CALL U1DREL(DELR,ANAME(1),NCOL,INDIS,IOUT)
      CALL U1DREL(DELC,ANAME(2),NROW,INDIS,IOUT)
C------Read the top elevation of layer 1.
      CALL U2DREL(TOP(1,1,1),ANAME(3),NROW,NCOL,1,INDIS,IOUT)
      
CCC13-----Read the bottom elevations.
      DO 120 K=1,NLAY
      KK=K
      CALL U2DREL(BOTM(:,:,K),ANAME(4),NROW,NCOL,KK,INDIS,IOUT)

  120 CONTINUE
C
C14-----READ AND WRITE LENGTH OF STRESS PERIOD, NUMBER OF TIME STEPS,
C14-----TIME STEP MULTIPLIER, AND STEADY-STATE FLAG..
cjed      WRITE(IOUT,161)
  161 FORMAT(1X,//1X,'STRESS PERIOD     LENGTH       TIME STEPS',
     1            '     MULTIPLIER FOR DELT    SS FLAG',/1X,76('-'))
      ISS=0
      ITR=0
      DO 200 N=1,NPER
      READ(INDIS,'(A)') LINE
      LLOC=1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,I,PERLEN(N),IOUT,INDIS)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NSTP(N),R,IOUT,INDIS)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,I,TSMULT(N),IOUT,INDIS)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,I,R,IOUT,INDIS)
      IF (LINE(ISTART:ISTOP).EQ.'TR') THEN
         ISSFLG(N)=0
         ITR=1
      ELSE IF (LINE(ISTART:ISTOP).EQ.'SS') THEN
         ISSFLG(N)=1
         ISS=1
      ELSE
cjed        WRITE(IOUT,162)
  162    FORMAT(' SSFLAG MUST BE EITHER "SS" OR "TR"',
     1      ' -- STOP EXECUTION (SGWF2BAS7ARDIS)')
         CALL USTOP(' ')
      END IF
cjed      WRITE (IOUT,163) N,PERLEN(N),NSTP(N),TSMULT(N),LINE(ISTART:ISTOP)
  163 FORMAT(1X,I8,1PG21.7,I7,0PF25.3,A11)
C
C15-----STOP IF NSTP LE 0, PERLEN EQ 0 FOR TRANSIENT STRESS PERIODS,
C15-----TSMULT LE 0, OR PERLEN LT 0..
      IF(NSTP(N).LE.0) THEN
cjed         WRITE(IOUT,164)
  164    FORMAT(1X,/1X,
     1  'THERE MUST BE AT LEAST ONE TIME STEP IN EVERY STRESS PERIOD')
         CALL USTOP(' ')
      END IF
      ZERO=0.
      IF(PERLEN(N).EQ.ZERO .AND. ISSFLG(N).EQ.0) THEN
cjed         WRITE(IOUT,165)
  165    FORMAT(1X,/1X,
     1  'PERLEN MUST NOT BE 0.0 FOR TRANSIENT STRESS PERIODS')
         CALL USTOP(' ')
      END IF
      IF(TSMULT(N).LE.ZERO) THEN
cjed         WRITE(IOUT,170)
  170    FORMAT(1X,/1X,'TSMULT MUST BE GREATER THAN 0.0')
         CALL USTOP(' ')
      END IF
      IF(PERLEN(N).LT.ZERO) THEN
cjed         WRITE(IOUT,175)
  175    FORMAT(1X,/1X,
     1  'PERLEN CANNOT BE LESS THAN 0.0 FOR ANY STRESS PERIOD')
         CALL USTOP(' ')
      END IF
  200 CONTINUE
C
C16-----Assign ITRSS.
      IF(ISS.EQ.0 .AND. ITR.NE.0) THEN
         ITRSS=1
cjed         WRITE(IOUT,270)
  270    FORMAT(/,1X,'TRANSIENT SIMULATION')
      ELSE IF(ISS.NE.0 .AND. ITR.EQ.0) THEN
         ITRSS=0
cjed         WRITE(IOUT,275)
  275    FORMAT(/,1X,'STEADY-STATE SIMULATION')
      ELSE
         ITRSS=-1
cjed         WRITE(IOUT,280)
  280    FORMAT(/,1X,'COMBINED STEADY-STATE AND TRANSIENT SIMULATION')
      END IF
C
C17-----RETURN.

      RETURN
      END SUBROUTINE RDDIS
C****************************************************************
      SUBROUTINE GETNUMSTART(IUIN,NSTART)
      IMPLICIT NONE
      INTEGER IUIN,NSTART
      
      NSTART=0
      DO
         READ(IUIN,*,END=50)
         NSTART = NSTART+1
      END DO
   50 CONTINUE
      REWIND(IUIN)
      RETURN
      END SUBROUTINE
      
C****************************************************************
      SUBROUTINE GETSTARTID(IUIN,NSTART,IDPART)
      IMPLICIT NONE
      
      INTEGER IUIN,N
      INTEGER J,I,K,JCODE,ICODE,KCODE,IDPART,IDMODEL_START
      INTEGER NSTART
      
      REAL X,Y,Z,TOT
      CHARACTER*40 PARTASSOC

      DIMENSION IDPART(NSTART)

      N=0
      DO
           N=N+1
           READ(IUIN,*,END=100) J,I,K,X,Y,Z,JCODE,ICODE,KCODE,TOT,
     1     IDPART(N),PARTASSOC
 
      END DO
  100 RETURN  
      END SUBROUTINE    