
C***** SUBROUTINE *****
      SUBROUTINE GRIDCOORD(NCOL,NROW,DELR,DELC,XMAX,YMAX)
      
      INTEGER JJ,II,JJDUMMY,IIDUMMY
      
      REAL DELR,DELC,XMAX,YMAX
      
      DIMENSION DELR(NCOL)
      DIMENSION DELC(NROW)

      DIMENSION XMAX(NCOL+1)
      DIMENSION YMAX(NROW+1)

C-------ASSIGN MAX VALUES FOR EACH DIRECTION 
      XMAX(1)=0
      DO JJ=2,NCOL+1
         JJDUMMY=JJ-1
         XMAX(JJ)=XMAX(JJDUMMY)+DELR(JJDUMMY)
      END DO
C-------REVERSE ORDER FOR Y-DIRECTION BECAUSE MODPATH ORIGIN IS AT LOWER LEFT         
      YMAX(NROW+1)=0.0                
      DO II=NROW,1,-1                   
         YMAX(II)=YMAX(II+1)+DELC(II)
      END DO

      END SUBROUTINE GRIDCOORD

C***** SUBROUTINE *****

C----READS ENDPOINT FILE AND CREATES A UNFORMATTED SCRATCH STARTING LOCATIONS FILE.
c    THE SCRATCH FILE IS READ BY SUBROUTINE DATIN
      SUBROUTINE EPFILE(IINENDOLD,IOUTSTART,NCOL,NROW,
     1 NLAY,DELR,DELC,TOP,BOTM,XOFF,YOFF,IZONE,IBFLG,NUMPART,XMAX,YMAX)

      IMPLICIT NONE
   
      INTEGER J,I,K,JC,IC,KC,NCOL,NROW,NLAY,IOUT
      INTEGER JNEW,INEW,KNEW,NPART,IDMODEL_START,IDMODEL
      INTEGER IOUTEPS,NUMPART
      INTEGER IDUMMY,IPCODE,KEEP,IFIRST,ILAST,IDCODE,IZONE,IZONE2
      INTEGER ICMPCT,JFRST,IFRST,KFRST,NSFRST,IBFLG,JCODE,ICODE,KCODE
      INTEGER IDPART,JJ,II,KK
      INTEGER IINENDOLD,IOUTSTART
      INTEGER MAXPTS
      
      REAL X,Y,Z,ZGLOB,XLOCNEW,YLOCNEW,ZLOCNEW,XOFF,YOFF,ZOFF
      REAL XNEW,YNEW,ZGLOBNEW
      REAL ZL,TOT,XSTRT,YSTRT,ZSTRT,ZLSTRT,TRLS,RDUMMY
      REAL DELR,DELC,TOP,BOTM,XMAX,YMAX
      
      CHARACTER*200 LINE
      CHARACTER*40 PARTASSOC

      DIMENSION DELR(NCOL)
      DIMENSION DELC(NROW)

      DIMENSION TOP(NCOL,NROW)
      DIMENSION BOTM(NCOL,NROW,NLAY)
      DIMENSION XMAX(NCOL+1)
      DIMENSION YMAX(NROW+1)
      
      JCODE=0
      ICODE=0
      KCODE=0
      NUMPART=0

      DO
      READ(IINENDOLD,END=100) IZONE,J,I,K,X,Y,ZGLOB,Z,TOT,XSTRT,YSTRT,
     1 ZLSTRT,JFRST,IFRST,KFRST,IZONE2,NSFRST,IPCODE,TRLS,ZSTRT,
     2 IDMODEL_START,IDMODEL,IDPART,PARTASSOC
     
         IF(IZONE.EQ.IBFLG) THEN
            NUMPART=NUMPART+1 ! increase count of particles
            XNEW=X-XOFF        
            YNEW=Y-YOFF        
            ZGLOBNEW=ZGLOB  
C----------GET NEW J,I,K FOR OFFSET PARTICLE LOCATIONS
            CALL XYZ2JIK(XNEW,YNEW,ZGLOBNEW,XLOCNEW,YLOCNEW,
     1      ZLOCNEW,J,I,K,JNEW,INEW,KNEW,NROW,NCOL,NLAY,
     2      DELR,DELC,TOP,BOTM,XMAX,YMAX)
C----------WRITE NEW STARTING LOCATIONS TO FILE
            WRITE(IOUTSTART) JNEW,INEW,KNEW,XLOCNEW,YLOCNEW,ZLOCNEW,
     1      JCODE,ICODE,KCODE,TOT,IDPART,PARTASSOC,IDMODEL_START
     
         END IF
      END DO     
      
 100  CONTINUE
      RETURN
      END
 
C**********************************************************************
      SUBROUTINE GRIDOFFSET(NROW,NCOL,DELR,DELC,NPCBEG,NPREND,NCPP,
     1 PXOFF,PYOFF,CXOFF,CYOFF)
     
      IMPLICIT NONE
      
      INTEGER NROW,NCOL
      INTEGER NPCBEG,NPREND,NCPP
      INTEGER LG,JJ,II
      REAL DELR,DELC
      REAL XOFF,YOFF
      REAL PXOFF,PYOFF,CXOFF,CYOFF
      DIMENSION DELR(NCOL),DELC(NROW)
  
      XOFF=0
      YOFF=0
      
      DO JJ=1,NPCBEG-1    
          XOFF=XOFF+DELR(JJ)
      END DO
      XOFF= XOFF+DELR(NPCBEG)*(REAL(INT(NCPP/2))/NCPP)
 
      DO II=NROW,NPREND+1,-1
          YOFF=YOFF+DELC(II)     
      END DO
      YOFF=YOFF+DELC(NPREND)*(REAL(INT(NCPP/2))/NCPP)
          
      CXOFF=XOFF
      CYOFF=YOFF
      PXOFF=-XOFF
      PYOFF=-YOFF
      
      RETURN
      END SUBROUTINE GRIDOFFSET

  
C**********************************************************************      
      SUBROUTINE XYZ2JIK(X,Y,ZGLOB,XLOCNEW,YLOCNEW,ZLOCNEW,J,I,K,
     1 JNEW,INEW,KNEW,NROW,NCOL,NLAY,DELR,DELC,TOP,BOTM,XMAX,YMAX)
   
      IMPLICIT NONE
      REAL X,Y,ZGLOB,XLOCNEW,YLOCNEW,ZLOCNEW,TOP,BOTM,XMAX,YMAX
      REAL DELR,DELC
      INTEGER NROW,NCOL,NLAY,J,I,K,JJ,II,KK,JNEW,INEW,KNEW,JJDUMMY

      DIMENSION DELR(NCOL)
      DIMENSION DELC(NROW)
      DIMENSION TOP(NROW,NCOL)
      DIMENSION BOTM(NROW,NCOL,NLAY)
      DIMENSION XMAX(NCOL+1)
      DIMENSION YMAX(NROW+1)
      
C       JJ COLUMN
C       II ROW
C       KK LAYER

      JNEW=0
      INEW=0
      KNEW=0

C-------FIND J COLUMN OF PARTICLE POSITION X      
      DO JJ=1,NCOL
         IF(X.GE.XMAX(JJ).AND.X.LT.XMAX(JJ+1)) THEN
         JNEW=JJ
         XLOCNEW=(X-XMAX(JJ))/(XMAX(JJ+1)-XMAX(JJ))
         EXIT
         END IF
      END DO

C-------FIND I ROW OF PARTICLE POSITION Y         
      DO II=NROW,1,-1
         IF(Y.GE.0.AND.Y.LT.YMAX(II)) THEN
         INEW=II
         YLOCNEW=(Y-YMAX(II+1))/(YMAX(II)-YMAX(II+1))
         EXIT
         END IF
      END DO
C-------FIND K LAYER OF PARTICLE POSITION Z
      DO KK=NLAY,2,-1
crth
!         DO JJ=1,NCOL
!            DO II=1,NROW

                IF(ZGLOB.GE.BOTM(INEW,JNEW,KK).AND.ZGLOB.LT.
     &              BOTM(II,JJ,KK-1)) THEN
                KNEW=KK
                ZLOCNEW=(ZGLOB-BOTM(II,JJ,KK))/
     1          (BOTM(II,JJ,KK-1)-BOTM(II,JJ,KK))
                EXIT
                ELSE 
                   KNEW=1
                   ZLOCNEW=(ZGLOB-BOTM(II,JJ,1))/(TOP(II,JJ)-
     &             BOTM(II,JJ,1))
                END IF
!                WRITE(*,'(3I5,3F10.3)') INEW,JNEW,KNEW,X,Y,ZGLOB
! crth            
!           END DO
!         END DO
      END DO
      RETURN
         
      END SUBROUTINE XYZ2JIK


C***** SUBROUTINE *****
      SUBROUTINE RDPATH(IUIN,IUOUT,ICMPCT,ISLGR,IDMODEL,XOFF,YOFF,ZOFF)
       
      INTEGER IUIN,IUOUT,ICMPCT,ND,K,NROW,NCOL,I,J,IP,NSTEP,NPARTNUM
      INTEGER ISLGR,IDMODEL
      REAL X,Y,ZL,Z,T
      CHARACTER*80 DUMMY

C     READ THE PATHLINE FILE
      IF(ICMPCT.EQ.1) THEN

          READ(IUIN,'(A)',END=3000) DUMMY
          WRITE(IUOUT,'(A)') DUMMY
          IF(ISLGR.EQ.0) THEN  ! read and write pathline MODPATH format+particle_ID
              DO   
                  READ(IUIN,1000,END=3000) IP,X,Y,ZL,Z,T,ND,NSTEP,
     1             NPARTVAL
                  WRITE(IUOUT,1000) IP,X,Y,ZL,Z,T,ND,NSTEP,NPARTVAL
              END DO
        
          ELSE           ! read and write pathline MODPATH-LGR format
              IF(IMODEL.EQ.1) THEN
                  DO
                     READ(IUIN,1010,END=3000) IP,X,Y,ZL,Z,T,ND,NSTEP,
     1                IDMODEL,NPARTNUM
                     WRITE(IUOUT,1010) IP,X,Y,ZL,Z,T,ND,NSTEP,IDMODEL,
     1                NPARTNUM
                  END DO
              ELSE IF(IMODEL.GT.1) THEN
                  DO
                     READ(IUIN,1010,END=3000) IP,CXOFF,CYOFF,ZL,
     1                CZOFF,T,ND,NSTEP,IDMODEL,NPARTVAL
                     WRITE(IUOUT,1010) IP,CXOFF,CYOFF,ZL,
     1                CZOFF,T,ND,NSTEP,IDMODEL,NPARTVAL
                  END DO
              END IF
          END IF
1000    FORMAT(I7,1X,1PE12.5,4(1X,E12.5),3(1X,I7))
1010    FORMAT(I7,1X,1PE12.5,4(1X,E12.5),4(1X,I7)) 
 
      ELSE IF(ICMPCT.EQ.2) THEN
          READ(IUIN,END=3000) DUMMY
          WRITE(IUOUT) DUMMY
          IF(ISLGR.EQ.0) THEN   ! read and write pathline MODPATH format+particle_ID
              DO
                  READ(IUIN,END=3000) IP,X,Y,ZL,Z,T,ND,NSTEP,NPARTVAL
                  WRITE(IUOUT) IP,X,Y,ZL,Z,T,ND,NSTEP,NPARTVAL
              END DO
          ELSE                  ! read and write pathline MODPATH-LGR format
              IF(IMODEL.EQ.1) THEN
                  DO
                      READ(IUIN,END=3000) IP,X,Y,ZL,Z,T,ND,NSTEP,
     1                 IDMODEL,NPARTVAL
                      WRITE(IUOUT) IP,X,Y,ZL,Z,T,ND,NSTEP,IDMODEL,
     1                 NPARTVAL
                  END DO
              ELSE IF(IMODEL.GT.1) THEN
                  DO
                      READ(IUIN,END=3000) IP,CXOFF,CYOFF,ZL,CZOFF,T,
     1                 ND,NSTEP,IDMODEL,NPARTVAL                 
                      WRITE(IUOUT) IP,CXOFF,CYOFF,ZL,CZOFF,T,ND,NSTEP,
     1                 IDMODEL,NPARTVAL
                  END DO
              END IF
          END IF
      
      ELSE
          READ(IUIN,'(A)',END=3000) DUMMY
          WRITE(IUOUT,'(A)') DUMMY
          IF(ISLGR.EQ.0) THEN   ! read and write pathline MODPATH format+particle_ID
              DO
                  READ(IUIN,2000,END=3000) IP,X,Y,ZL,Z,T,J,I,K,NSTEP,
     1             NPARTVAL
                  WRITE(IUOUT,2000) IP,X,Y,ZL,Z,T,J,I,K,NSTEP,NPARTVAL
              END DO
          ELSE                  ! read and write pathline MODPATH-LGR format
              IF(IMODEL.EQ.1) THEN
                  DO
                      READ(IUIN,2010,END=3000) IP,X,Y,ZL,Z,T,J,I,K,
     1                 NSTEP,IDMODEL,NPARTVAL
                      WRITE(IUOUT,2010) IP,X,Y,ZL,Z,T,J,I,K,
     1                 NSTEP,IDMODEL,NPARTVAL
                  END DO
          ELSE IF(IMODEL.GT.1) THEN
                  DO               
                      READ(IUIN,2010,END=3000) IP,CXOFF,CYOFF,ZL,
     1                 CZOFF,T,J,I,K,NSTEP,IDMODEL,NPARTVAL
                      WRITE(IUOUT,2010) IP,XOFF,YOFF,ZL,
     1                 CZOFF,T,J,I,K,NSTEP,IDMODEL,NPARTVAL
                  END DO
              END IF
          END IF    
2000  FORMAT(I7,1X,1PE12.5,4(1X,E12.5),3(1X,I4),1X,I7,1X,I7)
2010  FORMAT(I7,1X,1PE12.5,4(1X,E12.5),3(1X,I4),1X,I7,2(1X,I7))
      END IF
3000  RETURN
      END SUBROUTINE RDPATH



      
C***** SUBROUTINE *****
      SUBROUTINE RDTS(IUIN,IUOUT,ICMPCT,ISLGR,IDMODEL,XOFF,YOFF,ZOFF)
       
      INTEGER IUIN,IUOUT,ICMPCT,ISLGR,IDMODEL
      INTEGER MPSTP,NP,ND,NSTEP,NPARTVAL
      CHARACTER*80 DUMMY
      REAL X,Y,Z,ZL,T

C     READ THE TIME-SERIES FILE
      IF(ICMPCT.EQ.1) THEN
          READ(IUIN,'(A)',END=3000) DUMMY
          WRITE(IUOUT,'(A)') DUMMY
          IF(ISLGR.EQ.0) THEN  ! read and write time series MODPATH format+particle_ID
              DO   
                  READ(IU,1000,END=3000) MPSTP,NP,ND,X,Y,Z,ZL,T,NSTEP,
     1             NPARTVAL
                  WRITE(IU,1000) MPSTP,NP,ND,X,Y,Z,ZL,T,NSTEP,NPARTVAL
              END DO
        
          ELSE           ! read and write time series MODPATH-LGR format
              IF(IMODEL.EQ.1) THEN
                  DO
                     READ(IUOUTTS,1010,END=3000) MPSTP,NP,ND,X,Y,Z,ZL,T,
     1                NSTEP,IDMODEL,NPARTVAL
                     WRITE(IUOUTTS,1010) MPSTP,NP,ND,X,Y,Z,ZL,T,NSTEP,
     1                IDMODEL,NPARTVAL
                  END DO
              ELSE IF(IMODEL.GT.1) THEN
                  DO
                      READ(IUOUTTS,1010,END=3000) MPSTP,NP,ND,
     1                 CXOFF,CYOFF,CZOFF,ZL,T,NSTEP,IDMODEL,NPARTVAL
                      WRITE(IUOUTTS,1010) MPSTP,NP,ND,CXOFF,CYOFF,CZOFF
     1                 ,ZL,T,NSTEP,IDMODEL,NPARTVAL
                  END DO
              END IF
          END IF
1000  FORMAT(I4,2(1X,I7),1X,1PE12.5,4(1X,E12.5),2(1X,I7))
1010  FORMAT(I4,2(1X,I7),1X,1PE12.5,4(1X,E12.5),3(1X,I7))
 
      ELSE IF(ICMPCT.EQ.2) THEN
          READ(IUIN,END=3000) DUMMY
          WRITE(IUOUT) DUMMY
          IF(ISLGR.EQ.0) THEN   ! read and write time series MODPATH format+particle_ID
              DO
                  READ(IU,END=3000) MPSTP,NP,ND,X,Y,Z,ZL,T,NSTEP,
     1             NPARTVAL
                  WRITE(IU) MPSTP,NP,ND,X,Y,Z,ZL,T,NSTEP,NPARTVAL
              END DO
          ELSE                  ! read and write time series MODPATH-LGR format
              IF(IMODEL.EQ.1) THEN
                  DO
                      READ(IUOUTTS,END=3000) MPSTP,NP,ND,X,Y,Z,ZL,T,
     1                 NSTEP,IDMODEL,NPARTVAL
                      WRITE(IUOUTTS) MPSTP,NP,ND,X,Y,Z,ZL,T,NSTEP,
     1                 IDMODEL,NPARTVAL
                  END DO
              ELSE IF(IMODEL.GT.1) THEN
                  DO
                      READ(IUOUTTS,END=3000) MPSTP,NP,ND,
     1                 CXOFF,CYOFF,CZOFF,ZL,T,NSTEP,IDMODEL,NPARTVAL
                      WRITE(IUOUTTS) MPSTP,NP,ND,CXOFF,CYOFF,CZOFF,ZL,T,
     1                 NSTEP,IDMODEL,NPARTVAL
                  END DO
              END IF
          END IF
      
      ELSE
          IF(ISLGR.EQ.0) THEN   ! read and write time series MODPATH format+particle_ID
          READ(IUIN,'(A)',END=3000) DUMMY
          WRITE(IUOUT,'(A)') DUMMY
              DO
                  READ(IU,2000,END=3000) MPSTP,NP,J,I,K,X,Y,Z,ZL,T,
     1             NSTEP,NPARTVAL
                  WRITE(IU,2000) MPSTP,NP,J,I,K,X,Y,Z,ZL,T,NSTEP,
     1             NPARTVAL
              END DO
          ELSE                  ! read and write time series MODPATH-LGR format
              IF(IMODEL.EQ.1) THEN
                  DO
                      READ(IUOUTTS,2010,END=3000) MPSTP,NP,J,I,K,X,Y,Z,
     1                 ZL,T,NSTEP,IDMODEL,NPARTVAL
                      WRITE(IUOUTTS,2010) MPSTP,NP,J,I,K,X,Y,Z,ZL,T,
     1                 NSTEP,IDMODEL,NPARTVAL
                  END DO
          ELSE IF(IMODEL.GT.1) THEN
                  DO               
                      READ(IUOUTTS,2010,END=3000) MPSTP,NP,J,I,K,
     1                 CXOFF,CYOFF,CZOFF,ZL,T,NSTEP,IDMODEL,NPARTVAL
                      WRITE(IUOUTTS,2010) MPSTP,NP,J,I,K,
     1                 CXOFF,CYOFF,CZOFF,ZL,T,NSTEP,IDMODEL,NPARTVAL
                  END DO
              END IF
          END IF    
2000  FORMAT(I4,1X,I7,3(1X,I4),1X,1PE12.5,4(1X,E12.5),2(1X,I7))
2010  FORMAT(I4,1X,I7,3(1X,I4),1X,1PE12.5,4(1X,E12.5),3(1X,I7))
      END IF
3000  RETURN
      END SUBROUTINE RDTS



C***** SUBROUTINE *****      
      SUBROUTINE SORTPL(IUIN,IUOUT,ICMPCTP,IUSTART,NGRIDS,FNSTARTPARENT,
     1 FNSTARTCHILD)
      IMPLICIT NONE
      
      REAL TEMP_X,TEMP_Y,TEMP_ZL,TEMP_Z,TEMP_T
      REAL X,Y,ZL,Z,T
      
      INTEGER TEMP_IP,TEMP_J,TEMP_I,TEMP_K,TEMP_NSTEP
      INTEGER TEMP_IDMODEL_START,TEMP_IDMODEL,TEMP_NPARTVAL
      INTEGER IDSORT,NSTEPSTART
      INTEGER IUIN,IUOUT,IUSTART
      INTEGER ICMPCTP
      
      INTEGER NPSTART,NPSTARTID,NCSTART,NCSTARTID,NPALL,NGRIDS
      INTEGER NPALLSTARTID,NCSTARTMAX
      INTEGER N,L,ICOUNT,LG,NREC
      INTEGER IP,J,I,K,NSTEP,IDMODEL_START,IDMODEL,NPARTVAL
      
      CHARACTER*40 PARTASSOC,TEMP_PARTASSOC
      CHARACTER*80 FNSTARTPARENT,FNSTARTCHILD

      DIMENSION NCSTART(NGRIDS-1)
      DIMENSION FNSTARTCHILD(NGRIDS-1)
            
      ALLOCATABLE IP(:)
      ALLOCATABLE X(:)      
      ALLOCATABLE Y(:)      
      ALLOCATABLE ZL(:)     
      ALLOCATABLE Z(:)      
      ALLOCATABLE T(:)      
      ALLOCATABLE J(:)      
      ALLOCATABLE I(:)      
      ALLOCATABLE K(:)      
      ALLOCATABLE NSTEP(:)  
      ALLOCATABLE IDMODEL_START(:)
      ALLOCATABLE IDMODEL(:)
      ALLOCATABLE NPARTVAL(:)
      ALLOCATABLE PARTASSOC(:)
      
      ALLOCATABLE NPSTARTID(:)
      ALLOCATABLE NCSTARTID(:,:)
      ALLOCATABLE IDSORT(:)
      ALLOCATABLE NPALLSTARTID(:)
      LOGICAL SORTED      
      
C     FIRST GET NUMBER OF STARTING PARTICLES AND PARTICLE IDs
C     FOR PARENT GRID
      OPEN(IUSTART,FILE=FNSTARTPARENT,FORM='FORMATTED')
      CALL GETNUMSTART(IUSTART,NPSTART)
      
      ALLOCATE (NPSTARTID(NPSTART))
C     GET LIST OF STARTING IDs FOR PARENT MODEL
      CALL GETSTARTID(IUSTART,NPSTART,NPSTARTID)

      CLOSE(IUSTART)
C     FOR CHILD GRIDS
C     COUNT THE MOST STARTING PARTICLES IN ANY CHILD MODEL
      NCSTARTMAX=0
      DO LG=1,NGRIDS-1
         OPEN(IUSTART,FILE=FNSTARTCHILD(LG),FORM='FORMATTED')      
         CALL GETNUMSTART(IUSTART,NCSTART(LG))
         IF(NCSTART(LG).GT.NCSTARTMAX) NCSTARTMAX=NCSTART(LG)
         CLOSE(IUSTART)
      END DO
      
      ALLOCATE (NCSTARTID(NCSTARTMAX,NGRIDS-1))
C     GET LIST OF STARTING IDs FOR CHILD MODELS
      DO LG=1,NGRIDS-1
         OPEN(IUSTART,FILE=FNSTARTCHILD(LG),FORM='FORMATTED') 
         CALL GETSTARTID(IUSTART,NCSTART(LG),NCSTARTID(:,LG))
         CLOSE(IUSTART)
      END DO
      
C     COUNT THE TOTAL NUMBER OF PARTICLES      
      NPALL=NPSTART
      DO LG=1,NGRIDS-1
         NPALL=NPALL+NCSTART(LG)
      END DO

      ALLOCATE (NPALLSTARTID(NPALL))
      
C     MERGE ALL PARTICLE IDs TO ONE LIST
      ICOUNT=0
      DO N=1,NPSTART
         ICOUNT=ICOUNT+1
         NPALLSTARTID(ICOUNT)=NPSTARTID(N)
      END DO
      DO LG=1,NGRIDS-1
         DO N=1,NCSTART(LG)
            ICOUNT=ICOUNT+1
            NPALLSTARTID(ICOUNT)=NCSTARTID(N,LG)
         END DO
      END DO

C     COUNT THE NUMBER OF RECORDS IN THE GLOBAL PATHLINE FILE      

      NREC=0
      IF(ICMPCTP.EQ.2) THEN
         DO
            READ(IUIN,END=50) TEMP_IP,TEMP_X,TEMP_Y,TEMP_ZL,TEMP_Z,
     1       TEMP_T,TEMP_J,TEMP_I,TEMP_K,TEMP_NSTEP,TEMP_IDMODEL_START,
     2       TEMP_IDMODEL,TEMP_NPARTVAL,TEMP_PARTASSOC             
            
            NREC = NREC+1
         END DO
      ELSE 
         DO
            READ(IUIN,*,END=50)
            NREC = NREC+1
         END DO
      END IF

   50 CONTINUE
   
      REWIND(IUIN)
         
      ALLOCATE(IP(NREC))
      ALLOCATE(X(NREC)) 
      ALLOCATE(Y(NREC))     
      ALLOCATE(ZL(NREC))     
      ALLOCATE(Z(NREC))    
      ALLOCATE(T(NREC))     
      ALLOCATE(J(NREC))     
      ALLOCATE(I(NREC))     
      ALLOCATE(K(NREC))     
      ALLOCATE(NSTEP(NREC))  
      ALLOCATE(IDMODEL_START(NREC))
      ALLOCATE(IDMODEL(NREC))
      ALLOCATE(NPARTVAL(NREC))
      ALLOCATE(PARTASSOC(NREC)) 
      
      IF(ICMPCTP.EQ.2) THEN
         DO N=1,NREC
            READ(IUIN) IP(N),X(N),Y(N),ZL(N),Z(N),T(N),
     1       J(N),I(N),K(N),NSTEP(N),IDMODEL_START(N),IDMODEL(N),
     2       NPARTVAL(N),PARTASSOC(N) 
         END DO
         DO L=1,NPALL
            DO N=1,NREC
               IF(NPARTVAL(N).EQ.NPALLSTARTID(L)) THEN
                  WRITE(IUOUT) NPARTVAL(N),X(N),Y(N),ZL(N),Z(N),T(N),
     1             J(N),I(N),K(N),NSTEP(N),IDMODEL_START(N),IDMODEL(N),
     2             NPARTVAL(N),PARTASSOC(N)
               END IF
            END DO
         END DO
      ELSE
         DO N=1,NREC
            READ(IUIN,*) IP(N),X(N),Y(N),ZL(N),Z(N),T(N),
     1       J(N),I(N),K(N),NSTEP(N),IDMODEL_START(N),IDMODEL(N),
     2       NPARTVAL(N),PARTASSOC(N) 
         END DO
         DO L=1,NPALL
            DO N=1,NREC
               IF(NPARTVAL(N).EQ.NPALLSTARTID(L)) THEN
                  WRITE(IUOUT,100) NPARTVAL(N),X(N),Y(N),ZL(N),Z(N),
     1             T(N),J(N),I(N),K(N),NSTEP(N),IDMODEL_START(N),
     2             IDMODEL(N),NPARTVAL(N),PARTASSOC(N)
               END IF
            END DO
         END DO
      END IF      

  100 FORMAT(I7,1X,1PE12.5,4(1X,E12.5),3(1X,I4),1X,I7,3(1X,I7),1X,A)
      END SUBROUTINE SORTPL

C***** SUBROUTINE *****      
      SUBROUTINE SORTEP(IUIN,IUOUT,ICMPCTP)

      REAL TEMP_X,TEMP_Y,TEMP_ZGLOB,TEMP_Z,TEMP_TOT,TEMP_XSTRT
      REAL TEMP_YSTRT,TEMP_ZLSTRT,TEMP_TRLS,TEMP_ZSTRT
      INTEGER TEMP_IZONE,TEMP_J,TEMP_I,TEMP_K,TEMP_JFRST,TEMP_IFRST
      INTEGER TEMP_KFRST,TEMP_IZONE2,TEMP_NSFRST,TEMP_IPCODE,TEMP_IDPART
      INTEGER TEMP_IDMODEL_START,TEMP_IDMODEL
      INTEGER ICMPCTP
      CHARACTER*40 PARTASSOC,TEMP_PARTASSOC
      
      LOGICAL SORTED      

      ALLOCATABLE IZONE(:)
      ALLOCATABLE J(:)     
      ALLOCATABLE I(:) 
      ALLOCATABLE K(:)     
      ALLOCATABLE X(:) 
      ALLOCATABLE Y(:)
      ALLOCATABLE ZGLOB(:) 
      ALLOCATABLE Z(:)   
      ALLOCATABLE TOT(:)
      ALLOCATABLE XSTRT(:)      
      ALLOCATABLE YSTRT(:)      
      ALLOCATABLE ZLSTRT(:)          
      ALLOCATABLE JFRST(:)     
      ALLOCATABLE IFRST(:)     
      ALLOCATABLE KFRST(:)
      ALLOCATABLE IZONE2(:)      
      ALLOCATABLE NSFRST(:)      
      ALLOCATABLE IPCODE(:)
      ALLOCATABLE TRLS(:)
      ALLOCATABLE ZSTRT(:)
      ALLOCATABLE IDMODEL_START(:)
      ALLOCATABLE IDMODEL(:)
      ALLOCATABLE IDPART(:)
      ALLOCATABLE PARTASSOC(:)
      
      NREC=100000
!      IF(ICMPCTP.EQ.2) THEN ! BINARY FORMAT
!         DO
!            READ(IUIN,END=50)
!            NREC = NREC+1
!!            print*, NREC
!         END DO
!      ELSE
!         DO
!            READ(IUIN,*,END=50)
!            NREC = NREC+1
!         END DO
!      END IF

      
!   50 CONTINUE   
!      print*, NREC
!      REWIND(IUIN)
      
      ALLOCATE(IZONE(NREC))
      ALLOCATE(J(NREC))     
      ALLOCATE(I(NREC)) 
      ALLOCATE(K(NREC))     
      ALLOCATE(X(NREC)) 
      ALLOCATE(Y(NREC))
      ALLOCATE(ZGLOB(NREC)) 
      ALLOCATE(Z(NREC))    
      ALLOCATE(TOT(NREC))
      ALLOCATE(XSTRT(NREC))      
      ALLOCATE(YSTRT(NREC))      
      ALLOCATE(ZLSTRT(NREC))          
      ALLOCATE(JFRST(NREC))     
      ALLOCATE(IFRST(NREC))     
      ALLOCATE(KFRST(NREC))
      ALLOCATE(IZONE2(NREC))      
      ALLOCATE(NSFRST(NREC))      
      ALLOCATE(IPCODE(NREC))
      ALLOCATE(TRLS(NREC))
      ALLOCATE(ZSTRT(NREC))
      ALLOCATE(IDMODEL_START(NREC))
      ALLOCATE(IDMODEL(NREC))
      ALLOCATE(IDPART(NREC))
      ALLOCATE(PARTASSOC(NREC)) 

      SORTED = .FALSE.
      ISIZE=0
      ICOUNT=0
      N=1
      
C     SORT FOR IDPART(N)
      IF(ICMPCTP.EQ.2) THEN ! BINARY FORMAT
         
         DO 
!            print*, 'gets here'
            READ(IUIN,END=70) IZONE(N),J(N),I(N),K(N),
     1       X(N),Y(N),ZGLOB(N),Z(N),TOT(N),XSTRT(N),YSTRT(N),ZLSTRT(N),
     2       JFRST(N),IFRST(N),KFRST(N),IZONE2(N),NSFRST(N),IPCODE(N),
     3       TRLS(N),ZSTRT(N),IDMODEL_START(N),IDMODEL(N),IDPART(N),
     4       PARTASSOC(N)
!            print*, IZONE(N),J(N),I(N),K(N)

            N=N+1
            ISIZE=ISIZE+1
         END DO
      ELSE ! STANDARD FORMAT
         DO 
            READ(IUIN,*,END=70) IZONE(N),J(N),I(N),K(N),
     1       X(N),Y(N),ZGLOB(N),Z(N),TOT(N),XSTRT(N),YSTRT(N),ZLSTRT(N),
     2       JFRST(N),IFRST(N),KFRST(N),IZONE2(N),NSFRST(N),IPCODE(N),
     3       TRLS(N),ZSTRT(N),IDMODEL_START(N),IDMODEL(N),IDPART(N),
     4       PARTASSOC(N)

            N=N+1
            ISIZE=ISIZE+1
         END DO
      END IF
      
   70 CONTINUE 
      DO WHILE(.NOT.SORTED)
         SORTED = .TRUE.
         ICOUNT=ICOUNT+1
         DO N=1,ISIZE-ICOUNT
           IF(IDPART(N).GT.IDPART(N+1)) THEN
           TEMP_IZONE         = IZONE(N)        
           TEMP_J             = J(N)            
           TEMP_I             = I(N)            
           TEMP_K             = K(N)            
           TEMP_X             = X(N)            
           TEMP_Y             = Y(N)            
           TEMP_ZGLOB         = ZGLOB(N)        
           TEMP_Z             = Z(N)            
           TEMP_TOT           = TOT(N)          
           TEMP_XSTRT         = XSTRT(N)        
           TEMP_YSTRT         = YSTRT(N)        
           TEMP_ZLSTRT        = ZLSTRT(N)       
           TEMP_JFRST         = JFRST(N)        
           TEMP_IFRST         = IFRST(N)        
           TEMP_KFRST         = KFRST(N)        
           TEMP_IZONE2        = IZONE2(N)       
           TEMP_NSFRST        = NSFRST(N)       
           TEMP_IPCODE        = IPCODE(N)       
           TEMP_TRLS          = TRLS(N)         
           TEMP_ZSTRT         = ZSTRT(N)        
           TEMP_IDMODEL_START = IDMODEL_START(N)
           TEMP_IDMODEL       = IDMODEL(N)      
           TEMP_IDPART        = IDPART(N) 
           TEMP_PARTASSOC     = PARTASSOC(N) 
                      
           IZONE(N)           = IZONE(N+1)        
           J(N)               = J(N+1)            
           I(N)               = I(N+1)            
           K(N)               = K(N+1)            
           X(N)               = X(N+1)            
           Y(N)               = Y(N+1)            
           ZGLOB(N)           = ZGLOB(N+1)        
           Z(N)               = Z(N+1)            
           TOT(N)             = TOT(N+1)          
           XSTRT(N)           = XSTRT(N+1)        
           YSTRT(N)           = YSTRT(N+1)        
           ZLSTRT(N)          = ZLSTRT(N+1)       
           JFRST(N)           = JFRST(N+1)        
           IFRST(N)           = IFRST(N+1)        
           KFRST(N)           = KFRST(N+1)        
           IZONE2(N)          = IZONE2(N+1)       
           NSFRST(N)          = NSFRST(N+1)       
           IPCODE(N)          = IPCODE(N+1)       
           TRLS(N)            = TRLS(N+1)         
           ZSTRT(N)           = ZSTRT(N+1)        
           IDMODEL_START(N)   = IDMODEL_START(N+1)
           IDMODEL(N)         = IDMODEL(N+1)      
           IDPART(N)          = IDPART(N+1)
           PARTASSOC(N)       = PARTASSOC(N+1)
       
           IZONE(N+1)         =    TEMP_IZONE        
           J(N+1)             =    TEMP_J            
           I(N+1)             =    TEMP_I            
           K(N+1)             =    TEMP_K            
           X(N+1)             =    TEMP_X            
           Y(N+1)             =    TEMP_Y            
           ZGLOB(N+1)         =    TEMP_ZGLOB        
           Z(N+1)             =    TEMP_Z            
           TOT(N+1)           =    TEMP_TOT          
           XSTRT(N+1)         =    TEMP_XSTRT        
           YSTRT(N+1)         =    TEMP_YSTRT        
           ZLSTRT(N+1)        =    TEMP_ZLSTRT       
           JFRST(N+1)         =    TEMP_JFRST        
           IFRST(N+1)         =    TEMP_IFRST        
           KFRST(N+1)         =    TEMP_KFRST        
           IZONE2(N+1)        =    TEMP_IZONE2       
           NSFRST(N+1)        =    TEMP_NSFRST       
           IPCODE(N+1)        =    TEMP_IPCODE       
           TRLS(N+1)          =    TEMP_TRLS         
           ZSTRT(N+1)         =    TEMP_ZSTRT        
           IDMODEL_START(N+1) =    TEMP_IDMODEL_START
           IDMODEL(N+1)       =    TEMP_IDMODEL      
           IDPART(N+1)        =    TEMP_IDPART   
           PARTASSOC(N+1)     =    TEMP_PARTASSOC

           SORTED=.FALSE.
           END IF
         END DO
      END DO

C     FILTER OUT MULTIPLE ENDPOINTS FOR PARTICLES THAT EXIT MULTIPLE MODELS
C     KEEP THE STARTING LOCATIONS AND RELEASE TIMES FROM THE FIRST ENDPOINT RECORD

      COUNT=0       

      DO N=1,ISIZE
         IF(IDPART(N+1).EQ.IDPART(N)) THEN
            COUNT=COUNT+1
            XSTRT(N+1) = XSTRT(N+1-COUNT)
            YSTRT(N+1) = YSTRT(N+1-COUNT)
            ZLSTRT(N+1) = ZLSTRT(N+1-COUNT)
            JFRST(N+1) = JFRST(N+1-COUNT)
            IFRST(N+1) = IFRST(N+1-COUNT)
            KFRST(N+1) = KFRST(N+1-COUNT)
            IZONE2(N+1) = IZONE2(N+1-COUNT)
            NSFRST(N+1) = NSFRST(N+1-COUNT)
            TRLS(N+1) = TRLS(N+1-COUNT)
            ZSTRT(N+1) = ZSTRT(N+1-COUNT)
            PARTASSOC(N+1) = PARTASSOC(N+1-COUNT)
       
         ELSE
            IF(ICMPCTP.EQ.2) THEN ! BINARY FORMAT
               WRITE(IUOUT) IZONE(N),J(N),I(N),K(N),
     1          X(N),Y(N),ZGLOB(N),Z(N),TOT(N),XSTRT(N),YSTRT(N),
     2          ZLSTRT(N),JFRST(N),IFRST(N),KFRST(N),IZONE2(N),
     3          NSFRST(N),IPCODE(N),TRLS(N),ZSTRT(N),IDMODEL_START(N),
     4          IDMODEL(N),IDPART(N),PARTASSOC(N)
               COUNT=0
!               print*, IZONE(N),J(N),I(N),K(N)
            ELSE
               WRITE(IUOUT,100) IZONE(N),J(N),I(N),K(N),
     1          X(N),Y(N),ZGLOB(N),Z(N),TOT(N),XSTRT(N),YSTRT(N),
     2          ZLSTRT(N),JFRST(N),IFRST(N),KFRST(N),IZONE2(N),
     3          NSFRST(N),IPCODE(N),TRLS(N),ZSTRT(N),IDMODEL_START(N),
     4          IDMODEL(N),IDPART(N),PARTASSOC(N)
               COUNT=0
            END IF
          END IF
       END DO
       
  100  FORMAT(I3,3(1X,I4),1X,1PE12.5,7(1X,E12.5),3(1X,I4),1X,I3,1X,I5,
     1    1X,I6,2(1X,E12.5),3(1X,I6),1X,A)    
       END SUBROUTINE SORTEP
       
C***** SUBROUTINE *****      
      SUBROUTINE SORTTS(IUIN,IUOUT,ICMPCTP)

      REAL TEMP_X,TEMP_Y,TEMP_Z,TEMP_ZL,TEMP_T
      INTEGER TEMP_MPSTP,TEMP_NP,TEMP_J,TEMP_I,TEMP_K,TEMP_NSTEP
      INTEGER TEMP_IDMODEL_START,TEMP_IDMODEL,TEMP_NPARTVAL
      INTEGER ICMPCTP
      CHARACTER*40 PARTASSOC,TEMP_PARTASSOC

      ALLOCATABLE MPSTP(:)
      ALLOCATABLE NP(:)     
      ALLOCATABLE X(:)      
      ALLOCATABLE Y(:)      
      ALLOCATABLE ZL(:)     
      ALLOCATABLE Z(:)      
      ALLOCATABLE T(:)      
      ALLOCATABLE J(:)      
      ALLOCATABLE I(:)      
      ALLOCATABLE K(:)      
      ALLOCATABLE NSTEP(:)  
      ALLOCATABLE IDMODEL_START(:)
      ALLOCATABLE IDMODEL(:)
      ALLOCATABLE NPARTVAL(:)
      ALLOCATABLE PARTASSOC(:)
      
      LOGICAL SORTED      
      
      NREC=1
      DO
         READ(IUIN,*,END=50)
         NREC = NREC+1
      END DO
   50 CONTINUE   
      REWIND(IUIN)
      
      ALLOCATE(MPSTP(NREC))
      ALLOCATE(NP(NREC))     
      ALLOCATE(X(NREC)) 
      ALLOCATE(Y(NREC))     
      ALLOCATE(ZL(NREC))     
      ALLOCATE(Z(NREC))    
      ALLOCATE(T(NREC))     
      ALLOCATE(J(NREC))     
      ALLOCATE(I(NREC))     
      ALLOCATE(K(NREC))     
      ALLOCATE(NSTEP(NREC))  
      ALLOCATE(IDMODEL_START(NREC))
      ALLOCATE(IDMODEL(NREC))
      ALLOCATE(NPARTVAL(NREC))
      ALLOCATE(PARTASSOC(NREC)) 
      
C     BUBBLE SORT
      SORTED = .FALSE.
      ISIZE=0
      ICOUNT=0
      N=1
     
C     SORT FOR NSTEP(N)
      DO 
         READ(IUIN,*,END=70) MPSTP(N),NP(N),J(N),I(N),K(N),X(N),
     1    Y(N),Z(N),ZL(N),T(N),NSTEP(N),IDMODEL_START(N),IDMODEL(N),
     2    NPARTVAL(N),PARTASSOC(N)
         N=N+1
         ISIZE=ISIZE+1
      END DO
   70 CONTINUE 
       DO WHILE(.NOT.SORTED)
         SORTED = .TRUE.
         ICOUNT=ICOUNT+1
         DO N=1,ISIZE-ICOUNT        
           IF(MPSTP(N).GT.MPSTP(N+1)) THEN
           TEMP_MPSTP    = MPSTP(N)
           TEMP_NP       = NP(N)    
           TEMP_X        = X(N)      
           TEMP_Y        = Y(N)
           TEMP_ZL       = ZL(N)
           TEMP_Z        = Z(N)
           TEMP_T        = T(N)
           TEMP_J        = J(N)
           TEMP_I        = I(N)
           TEMP_K        = K(N)
           TEMP_T        = T(N)
           TEMP_NSTEP    = NSTEP(N)
           TEMP_IDMODEL_START  = IDMODEL_START(N)           
           TEMP_IDMODEL  = IDMODEL(N)
           TEMP_NPARTVAL = NPARTVAL(N)
           TEMP_PARTASSOC= PARTASSOC(N)
           
           MPSTP(N)    = MPSTP(N+1)
           NP(N)       = NP(N+1)    
           X(N)        = X(N+1)       
           Y(N)        = Y(N+1)       
           ZL(N)       = ZL(N+1)      
           Z(N)        = Z(N+1)       
           T(N)        = T(N+1)       
           J(N)        = J(N+1)       
           I(N)        = I(N+1)       
           K(N)        = K(N+1)       
           NSTEP(N)    = NSTEP(N+1)
           IDMODEL_START(N)  = IDMODEL_START(N+1)              
           IDMODEL(N)  = IDMODEL(N+1) 
           NPARTVAL(N) = NPARTVAL(N+1)
           PARTASSOC(N)= PARTASSOC(N+1)
  
           MPSTP(N+1)   = TEMP_MPSTP
           NP(N+1)      = TEMP_NP
           X(N+1)       = TEMP_X       
           Y(N+1)       = TEMP_Y       
           ZL(N+1)      = TEMP_ZL      
           Z(N+1)       = TEMP_Z       
           T(N+1)       = TEMP_T       
           J(N+1)       = TEMP_J       
           I(N+1)       = TEMP_I       
           K(N+1)       = TEMP_K       
           NSTEP(N+1)   = TEMP_NSTEP   
           IDMODEL_START(N+1) = TEMP_IDMODEL_START 
           IDMODEL(N+1) = TEMP_IDMODEL 
           NPARTVAL(N+1)= TEMP_NPARTVAL
           PARTASSOC(N+1) = TEMP_PARTASSOC
           
           SORTED=.FALSE.
           END IF
         END DO
       END DO
       DO N=1,ISIZE
       WRITE(IUOUT,100) MPSTP(N),NP(N),J(N),I(N),K(N),X(N),
     1   Y(N),Z(N),ZL(N),T(N),NSTEP(N),IDMODEL_START(N),IDMODEL(N),
     2   NPARTVAL(N),PARTASSOC(N) 

       END DO
  100  FORMAT(2I7,1X,3(1X,I4),1X,1PE12.5,4(1X,E12.5),4(1X,I7),2X,A)
       END SUBROUTINE SORTTS


C***** SUBROUTINE *****      
      SUBROUTINE SORTADVOBS(IUIN,IUOUT)

      REAL TEMP_X,TEMP_Y,TEMP_Z,TEMP_ZL,TEMP_T
      INTEGER TEMP_MPSTP,TEMP_NP,TEMP_J,TEMP_I,TEMP_K,TEMP_NSTEP
      INTEGER TEMP_IDMODEL_START,TEMP_IDMODEL,TEMP_NPARTVAL
      CHARACTER*40 PARTASSOC,TEMP_PARTASSOC

      DIMENSION MPSTP(5000000)
      DIMENSION NP(5000000)     
      DIMENSION X(5000000)      
      DIMENSION Y(5000000)      
      DIMENSION ZL(5000000)     
      DIMENSION Z(5000000)      
      DIMENSION T(5000000)      
      DIMENSION J(5000000)      
      DIMENSION I(5000000)      
      DIMENSION K(5000000)      
      DIMENSION NSTEP(5000000)  
      DIMENSION IDMODEL_START(5000000)
      DIMENSION IDMODEL(5000000)
      DIMENSION NPARTVAL(5000000)
      DIMENSION PARTASSOC(5000000)     

      
      LOGICAL SORTED      

      SORTED = .FALSE.
      ISIZE=0
      ICOUNT=0
      N=1

C     SORT FOR NSTEP(N)
      DO 
         READ(IUIN,*,END=70) MPSTP(N),NP(N),J(N),I(N),K(N),X(N),
     1    Y(N),Z(N),ZL(N),T(N),NSTEP(N),IDMODEL_START(N),IDMODEL(N),
     2    NPARTVAL(N),PARTASSOC(N)
         N=N+1
         ISIZE=ISIZE+1
      END DO
   70 CONTINUE 
       DO WHILE(.NOT.SORTED)
         SORTED = .TRUE.
         ICOUNT=ICOUNT+1
         DO N=1,ISIZE-ICOUNT        
           IF(MPSTP(N).GT.MPSTP(N+1)) THEN
           TEMP_MPSTP    = MPSTP(N)
           TEMP_NP       = NP(N)    
           TEMP_X        = X(N)      
           TEMP_Y        = Y(N)
           TEMP_ZL       = ZL(N)
           TEMP_Z        = Z(N)
           TEMP_T        = T(N)
           TEMP_J        = J(N)
           TEMP_I        = I(N)
           TEMP_K        = K(N)
           TEMP_T        = T(N)
           TEMP_NSTEP    = NSTEP(N)
           TEMP_IDMODEL_START  = IDMODEL_START(N)           
           TEMP_IDMODEL  = IDMODEL(N)
           TEMP_NPARTVAL = NPARTVAL(N)
           TEMP_PARTASSOC= PARTASSOC(N)
           
           MPSTP(N)    = MPSTP(N+1)
           NP(N)       = NP(N+1)    
           X(N)        = X(N+1)       
           Y(N)        = Y(N+1)       
           ZL(N)       = ZL(N+1)      
           Z(N)        = Z(N+1)       
           T(N)        = T(N+1)       
           J(N)        = J(N+1)       
           I(N)        = I(N+1)       
           K(N)        = K(N+1)       
           NSTEP(N)    = NSTEP(N+1)
           IDMODEL_START(N)  = IDMODEL_START(N+1)              
           IDMODEL(N)  = IDMODEL(N+1) 
           NPARTVAL(N) = NPARTVAL(N+1)
           PARTASSOC(N)= PARTASSOC(N+1)
  
           MPSTP(N+1)   = TEMP_MPSTP
           NP(N+1)      = TEMP_NP
           X(N+1)       = TEMP_X       
           Y(N+1)       = TEMP_Y       
           ZL(N+1)      = TEMP_ZL      
           Z(N+1)       = TEMP_Z       
           T(N+1)       = TEMP_T       
           J(N+1)       = TEMP_J       
           I(N+1)       = TEMP_I       
           K(N+1)       = TEMP_K       
           NSTEP(N+1)   = TEMP_NSTEP   
           IDMODEL_START(N+1) = TEMP_IDMODEL_START 
           IDMODEL(N+1) = TEMP_IDMODEL 
           NPARTVAL(N+1)= TEMP_NPARTVAL
           PARTASSOC(N+1) = TEMP_PARTASSOC
           
           SORTED=.FALSE.
           END IF
         END DO
       END DO
       DO N=1,ISIZE
       WRITE(IUOUT,100) MPSTP(N),NP(N),J(N),I(N),K(N),X(N),
     1   Y(N),Z(N),ZL(N),T(N),NSTEP(N),IDMODEL_START(N),IDMODEL(N),
     2   NPARTVAL(N),PARTASSOC(N) 

       END DO
  100  FORMAT(2I7,1X,3(1X,I4),1X,1PE12.5,4(1X,E12.5),4(1X,I7),2X,A)
       END SUBROUTINE SORTADVOBS

C************************************************************************
      SUBROUTINE ADDMODELID(IN,IOUT,IDMODEL_START)
      
      CHARACTER*250 LINE
      DO
      READ(IN,'(A)',END=190) LINE
      IF(LINE.EQ.' ') GO TO 190
      ICOL=1
      CALL URWORD(LINE,ICOL,IWSTRT,IWLAST,2,J,RDUMMY,I7,I6)
      CALL URWORD(LINE,ICOL,IWSTRT,IWLAST,2,I,RDUMMY,I7,I6)
      CALL URWORD(LINE,ICOL,IWSTRT,IWLAST,2,K,RDUMMY,I7,I6)
      CALL URWORD(LINE,ICOL,IWSTRT,IWLAST,3,NDUMMY,XVALUE,I7,I6)
      CALL URWORD(LINE,ICOL,IWSTRT,IWLAST,3,NDUMMY,YVALUE,I7,I6)
      CALL URWORD(LINE,ICOL,IWSTRT,IWLAST,3,NDUMMY,ZVALUE,I7,I6)
      CALL URWORD(LINE,ICOL,IWSTRT,IWLAST,2,JCODE,RDUMMY,I7,I6)
      IF(LINE(IWSTRT:IWLAST).EQ.' ') THEN
          JCODE=0
          ICODE=0
          KCODE=0
          TRLEAS=0.0
      ELSE
        CALL URWORD(LINE,ICOL,IWSTRT,IWLAST,2,ICODE,RDUMMY,I7,I6)
        CALL URWORD(LINE,ICOL,IWSTRT,IWLAST,2,KCODE,RDUMMY,I7,I6)
        CALL URWORD(LINE,ICOL,IWSTRT,IWLAST,3,NDUMMY,TRLEAS,I7,I6)
cjed added new line to read NPARTVAL
        CALL URWORD(LINE,ICOL,IWSTRT,IWLAST,2,NPARTVAL,RDUMMY,I7,I6)
c        CALL URWORD(LINE,ICOL,IWSTRT,IWLAST,2,IDMODEL_START,
c     1   RDUMMY,I7,I6)
      END IF

C----------WRITE STARTING LOCATIONS TO FILE
      WRITE(IOUT,50) J,I,K,XVALUE,YVALUE,ZVALUE,JCODE,ICODE,
     1 KCODE,TRLEAS,NPARTVAL,IDMODEL_START
  50     FORMAT(3I5,3E15.6,3I5,E15.6,2I10)        
      END DO
  190 CONTINUE         
      RETURN
      END SUBROUTINE
      
